// $Id: Padma.js,v 1.1.2.6 2005/07/11 17:42:49 vnagarjuna Exp $ -->

//Copyright 2005 Nagarjuna Venna <vnagarjuna@yahoo.com>

/* ***** BEGIN LICENSE BLOCK ***** 
 *  This file is part of Padma.
 *
 *  Padma is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.

 *  Padma is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Padma; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *
 * ***** END LICENSE BLOCK ***** */

//Internal format - This is my way of expressing displeasure with the Unicode standard
//IMHO, Unicode is not consistent, not optimized and is unintuitive.
function Padma()
{
}

//Types
Padma.type_accu     = 0;
Padma.type_gunimtam = 1;
Padma.type_spaccu   = 2;    //anusvara, visarga, pollu
Padma.type_digit    = 3;
Padma.type_vattu    = 4;
Padma.type_hallu    = 5;
Padma.type_unknown  = 6;

//Don't use character codes 0-64, 91-96, 123-127

//The highest code used currently is 0xFD.

//Specials
Padma.candrabindu = "\u00A0";
Padma.visarga     = "\u00A1";
Padma.pollu       = "\u00A2";
Padma.anusvara    = "\u00A3";
Padma.avagraha    = "\u00A4";
Padma.yati        = "\u00A5";   //vertical diamond filled dark (classical), sometimes asterisk
Padma.udAtta      = "\u00A6";   //this and the next 2 are vedic symbols
Padma.anudAtta    = "\u00A7";
Padma.svarita     = "\u00A8";   //equivalent of udAtta
Padma.guru        = "\u00A9";
Padma.laghu       = "\u00AA";
Padma.danda       = "\u00AB";   //comma
Padma.ddanda      = "\u00AC";   //full stop (double danda)

//digits
Padma.digit_ZERO  = "\u00B0";
Padma.digit_ONE   = "\u00B1";
Padma.digit_TWO   = "\u00B2";
Padma.digit_THREE = "\u00B3";
Padma.digit_FOUR  = "\u00B4";
Padma.digit_FIVE  = "\u00B5";
Padma.digit_SIX   = "\u00B6";
Padma.digit_SEVEN = "\u00B7";
Padma.digit_EIGHT = "\u00B8";
Padma.digit_NINE  = "\u00B9";

//Vowels
Padma.vowel_A     = "\u00BA";
Padma.vowel_AA    = "\u0041";
Padma.vowel_I     = "\u0042";
Padma.vowel_II    = "\u0043";
Padma.vowel_U     = "\u0044";
Padma.vowel_UU    = "\u0045";
Padma.vowel_R     = "\u0046";
Padma.vowel_RR    = "\u0047";
Padma.vowel_L     = "\u0048";
Padma.vowel_LL    = "\u0049";
Padma.vowel_E     = "\u004A";
Padma.vowel_EE    = "\u004B";
Padma.vowel_AI    = "\u004C";
Padma.vowel_O     = "\u004D";
Padma.vowel_OO    = "\u004E";
Padma.vowel_AU    = "\u004F";

//Consonants
Padma.consnt_KA   = "\u0050";
Padma.consnt_KHA  = "\u0051";
Padma.consnt_GA   = "\u0052";
Padma.consnt_GHA  = "\u0053";
Padma.consnt_NGA  = "\u0054";
Padma.consnt_CA   = "\u0055";
Padma.consnt_CHA  = "\u0056";
Padma.consnt_JA   = "\u0057";
Padma.consnt_JHA  = "\u0058";
Padma.consnt_NYA  = "\u0059";
Padma.consnt_TTA  = "\u005A";
Padma.consnt_TTHA = "\u0061";
Padma.consnt_DDA  = "\u0062";
Padma.consnt_DDHA = "\u0063";
Padma.consnt_NNA  = "\u0064";
Padma.consnt_TA   = "\u0065";
Padma.consnt_THA  = "\u0066";
Padma.consnt_DA   = "\u0067";
Padma.consnt_DHA  = "\u0068";
Padma.consnt_NA   = "\u0069";
Padma.consnt_PA   = "\u006A";
Padma.consnt_PHA  = "\u006B";
Padma.consnt_BA   = "\u006C";
Padma.consnt_BHA  = "\u006D";
Padma.consnt_MA   = "\u006E";
Padma.consnt_YA   = "\u006F";
Padma.consnt_RA   = "\u0070";
Padma.consnt_LA   = "\u0071";
Padma.consnt_VA   = "\u0072";
Padma.consnt_SHA  = "\u0073";
Padma.consnt_SSA  = "\u0074";
Padma.consnt_SA   = "\u0075";
Padma.consnt_HA   = "\u0076";
Padma.consnt_LLA  = "\u0077";
Padma.consnt_KSH  = "\u0078";   
Padma.consnt_RRA  = "\u0079";

//extinct consonants
Padma.consnt_TCH  = "\u007A";
Padma.consnt_TJ   = "\u007B";

//Gunimtaalu
Padma.vowelsn_AA  = "\u00C1";
Padma.vowelsn_I   = "\u00C2";
Padma.vowelsn_II  = "\u00C3";
Padma.vowelsn_U   = "\u00C4";
Padma.vowelsn_UU  = "\u00C5";
Padma.vowelsn_R   = "\u00C6";
Padma.vowelsn_RR  = "\u00C7";
Padma.vowelsn_L   = "\u00C8";
Padma.vowelsn_LL  = "\u00C9";
Padma.vowelsn_E   = "\u00CA";
Padma.vowelsn_EE  = "\u00CB";
Padma.vowelsn_AI  = "\u00CC";
Padma.vowelsn_O   = "\u00CD";
Padma.vowelsn_OO  = "\u00CE";
Padma.vowelsn_AU  = "\u00CF";
Padma.vowelsn_EELEN = "\u00FD";
Padma.vowelsn_AILEN = "\u00FC";

//vattulu
Padma.vattu_KA    = "\u00D0";
Padma.vattu_KHA   = "\u00D1";
Padma.vattu_GA    = "\u00D2";
Padma.vattu_GHA   = "\u00D3";
Padma.vattu_NGA   = "\u00D4";
Padma.vattu_CA    = "\u00D5";
Padma.vattu_CHA   = "\u00D6";
Padma.vattu_JA    = "\u00D7";
Padma.vattu_JHA   = "\u00D8";
Padma.vattu_NYA   = "\u00D9";
Padma.vattu_TTA   = "\u00DA";
Padma.vattu_TTHA  = "\u00E1";
Padma.vattu_DDA   = "\u00E2";
Padma.vattu_DDHA  = "\u00E3";
Padma.vattu_NNA   = "\u00E4";
Padma.vattu_TA    = "\u00E5";
Padma.vattu_THA   = "\u00E6";
Padma.vattu_DA    = "\u00E7";
Padma.vattu_DHA   = "\u00E8";
Padma.vattu_NA    = "\u00E9";
Padma.vattu_PA    = "\u00EA";
Padma.vattu_PHA   = "\u00EB";
Padma.vattu_BA    = "\u00EC";
Padma.vattu_BHA   = "\u00ED";
Padma.vattu_MA    = "\u00EE";
Padma.vattu_YA    = "\u00EF";
Padma.vattu_RA    = "\u00F0";
Padma.vattu_LA    = "\u00F1";
Padma.vattu_VA    = "\u00F2";
Padma.vattu_SHA   = "\u00F3";
Padma.vattu_SSA   = "\u00F4";
Padma.vattu_SA    = "\u00F5";
Padma.vattu_HA    = "\u00F6";
Padma.vattu_LLA   = "\u00F7";
Padma.vattu_KSH   = "\u00F8";   
Padma.vattu_RRA   = "\u00F9";
Padma.vattu_TCH   = "\u00FA";
Padma.vattu_TJ    = "\u00FB";

//Symbol table
Padma.symbols = new Array();
Padma.symbols[Padma.vowel_A]     = Padma.type_accu;
Padma.symbols[Padma.vowel_AA]    = Padma.type_accu;
Padma.symbols[Padma.vowel_I]     = Padma.type_accu;
Padma.symbols[Padma.vowel_II]    = Padma.type_accu;
Padma.symbols[Padma.vowel_U]     = Padma.type_accu;
Padma.symbols[Padma.vowel_UU]    = Padma.type_accu;
Padma.symbols[Padma.vowel_R]     = Padma.type_accu;
Padma.symbols[Padma.vowel_RR]    = Padma.type_accu;
Padma.symbols[Padma.vowel_L]     = Padma.type_accu;
Padma.symbols[Padma.vowel_LL]    = Padma.type_accu;
Padma.symbols[Padma.vowel_E]     = Padma.type_accu;
Padma.symbols[Padma.vowel_EE]    = Padma.type_accu;
Padma.symbols[Padma.vowel_AI]    = Padma.type_accu;
Padma.symbols[Padma.vowel_O]     = Padma.type_accu;
Padma.symbols[Padma.vowel_OO]    = Padma.type_accu;
Padma.symbols[Padma.vowel_AU]    = Padma.type_accu;

Padma.symbols[Padma.candrabindu] = Padma.type_unknown;
Padma.symbols[Padma.visarga]     = Padma.type_accu;
Padma.symbols[Padma.pollu]       = Padma.type_spaccu;
Padma.symbols[Padma.anusvara]    = Padma.type_accu;
Padma.symbols[Padma.avagraha]    = Padma.type_unknown;
Padma.symbols[Padma.yati]        = Padma.type_unknown;
Padma.symbols[Padma.udAtta]      = Padma.type_unknown;
Padma.symbols[Padma.anudAtta]    = Padma.type_unknown;
Padma.symbols[Padma.svarita]     = Padma.type_unknown;
Padma.symbols[Padma.guru]        = Padma.type_unknown;
Padma.symbols[Padma.laghu]       = Padma.type_unknown;
Padma.symbols[Padma.danda]       = Padma.type_unknown;
Padma.symbols[Padma.ddanda]      = Padma.type_unknown;

Padma.symbols[Padma.digit_ZERO]  = Padma.type_digit;
Padma.symbols[Padma.digit_ONE]   = Padma.type_digit;
Padma.symbols[Padma.digit_TWO]   = Padma.type_digit;
Padma.symbols[Padma.digit_THREE] = Padma.type_digit;
Padma.symbols[Padma.digit_FOUR]  = Padma.type_digit;
Padma.symbols[Padma.digit_FIVE]  = Padma.type_digit;
Padma.symbols[Padma.digit_SIX]   = Padma.type_digit;
Padma.symbols[Padma.digit_SEVEN] = Padma.type_digit;
Padma.symbols[Padma.digit_EIGHT] = Padma.type_digit;
Padma.symbols[Padma.digit_NINE]  = Padma.type_digit;

Padma.symbols[Padma.consnt_KA]   = Padma.type_hallu;
Padma.symbols[Padma.consnt_KHA]  = Padma.type_hallu;
Padma.symbols[Padma.consnt_GA]   = Padma.type_hallu;
Padma.symbols[Padma.consnt_GHA]  = Padma.type_hallu;
Padma.symbols[Padma.consnt_NGA]  = Padma.type_hallu;
Padma.symbols[Padma.consnt_CA]   = Padma.type_hallu;
Padma.symbols[Padma.consnt_CHA]  = Padma.type_hallu;
Padma.symbols[Padma.consnt_JA]   = Padma.type_hallu;
Padma.symbols[Padma.consnt_JHA]  = Padma.type_hallu;
Padma.symbols[Padma.consnt_NYA]  = Padma.type_hallu;
Padma.symbols[Padma.consnt_TTA]  = Padma.type_hallu;
Padma.symbols[Padma.consnt_TTHA] = Padma.type_hallu;
Padma.symbols[Padma.consnt_DDA]  = Padma.type_hallu;
Padma.symbols[Padma.consnt_DDHA] = Padma.type_hallu;
Padma.symbols[Padma.consnt_NNA]  = Padma.type_hallu;
Padma.symbols[Padma.consnt_TA]   = Padma.type_hallu;
Padma.symbols[Padma.consnt_THA]  = Padma.type_hallu;
Padma.symbols[Padma.consnt_DA]   = Padma.type_hallu;
Padma.symbols[Padma.consnt_DHA]  = Padma.type_hallu;
Padma.symbols[Padma.consnt_NA]   = Padma.type_hallu;
Padma.symbols[Padma.consnt_PA]   = Padma.type_hallu;
Padma.symbols[Padma.consnt_PHA]  = Padma.type_hallu;
Padma.symbols[Padma.consnt_BA]   = Padma.type_hallu;
Padma.symbols[Padma.consnt_BHA]  = Padma.type_hallu;
Padma.symbols[Padma.consnt_MA]   = Padma.type_hallu;
Padma.symbols[Padma.consnt_YA]   = Padma.type_hallu;
Padma.symbols[Padma.consnt_RA]   = Padma.type_hallu;
Padma.symbols[Padma.consnt_LA]   = Padma.type_hallu;
Padma.symbols[Padma.consnt_VA]   = Padma.type_hallu;
Padma.symbols[Padma.consnt_SHA]  = Padma.type_hallu;
Padma.symbols[Padma.consnt_SSA]  = Padma.type_hallu;
Padma.symbols[Padma.consnt_SA]   = Padma.type_hallu;
Padma.symbols[Padma.consnt_HA]   = Padma.type_hallu;
Padma.symbols[Padma.consnt_LLA]  = Padma.type_hallu;
Padma.symbols[Padma.consnt_KSH]  = Padma.type_hallu;   
Padma.symbols[Padma.consnt_RRA]  = Padma.type_hallu;
Padma.symbols[Padma.consnt_TCH]  = Padma.type_hallu;
Padma.symbols[Padma.consnt_TJ]   = Padma.type_hallu;

Padma.symbols[Padma.vowelsn_AA]  = Padma.type_gunimtam;
Padma.symbols[Padma.vowelsn_I]   = Padma.type_gunimtam;
Padma.symbols[Padma.vowelsn_II]  = Padma.type_gunimtam;
Padma.symbols[Padma.vowelsn_U]   = Padma.type_gunimtam;
Padma.symbols[Padma.vowelsn_UU]  = Padma.type_gunimtam;
Padma.symbols[Padma.vowelsn_R]   = Padma.type_gunimtam;
Padma.symbols[Padma.vowelsn_RR]  = Padma.type_gunimtam;
Padma.symbols[Padma.vowelsn_L]   = Padma.type_gunimtam;
Padma.symbols[Padma.vowelsn_LL]  = Padma.type_gunimtam;
Padma.symbols[Padma.vowelsn_E]   = Padma.type_gunimtam;
Padma.symbols[Padma.vowelsn_EE]  = Padma.type_gunimtam;
Padma.symbols[Padma.vowelsn_AI]  = Padma.type_gunimtam;
Padma.symbols[Padma.vowelsn_O]   = Padma.type_gunimtam;
Padma.symbols[Padma.vowelsn_OO]  = Padma.type_gunimtam;
Padma.symbols[Padma.vowelsn_AU]  = Padma.type_gunimtam;
Padma.symbols[Padma.vowelsn_EELEN]  = Padma.type_gunimtam;
Padma.symbols[Padma.vowelsn_AILEN]  = Padma.type_gunimtam;

Padma.symbols[Padma.vattu_KA]    = Padma.type_vattu;
Padma.symbols[Padma.vattu_KHA]   = Padma.type_vattu;
Padma.symbols[Padma.vattu_GA]    = Padma.type_vattu;
Padma.symbols[Padma.vattu_GHA]   = Padma.type_vattu;
Padma.symbols[Padma.vattu_NGA]   = Padma.type_vattu;
Padma.symbols[Padma.vattu_CA]    = Padma.type_vattu;
Padma.symbols[Padma.vattu_CHA]   = Padma.type_vattu;
Padma.symbols[Padma.vattu_JA]    = Padma.type_vattu;
Padma.symbols[Padma.vattu_JHA]   = Padma.type_vattu;
Padma.symbols[Padma.vattu_NYA]   = Padma.type_vattu;
Padma.symbols[Padma.vattu_TTA]   = Padma.type_vattu;
Padma.symbols[Padma.vattu_TTHA]  = Padma.type_vattu;
Padma.symbols[Padma.vattu_DDA]   = Padma.type_vattu;
Padma.symbols[Padma.vattu_DDHA]  = Padma.type_vattu;
Padma.symbols[Padma.vattu_NNA]   = Padma.type_vattu;
Padma.symbols[Padma.vattu_TA]    = Padma.type_vattu;
Padma.symbols[Padma.vattu_THA]   = Padma.type_vattu;
Padma.symbols[Padma.vattu_DA]    = Padma.type_vattu;
Padma.symbols[Padma.vattu_DHA]   = Padma.type_vattu;
Padma.symbols[Padma.vattu_NA]    = Padma.type_vattu;
Padma.symbols[Padma.vattu_PA]    = Padma.type_vattu;
Padma.symbols[Padma.vattu_PHA]   = Padma.type_vattu;
Padma.symbols[Padma.vattu_BA]    = Padma.type_vattu;
Padma.symbols[Padma.vattu_BHA]   = Padma.type_vattu;
Padma.symbols[Padma.vattu_MA]    = Padma.type_vattu;
Padma.symbols[Padma.vattu_YA]    = Padma.type_vattu;
Padma.symbols[Padma.vattu_RA]    = Padma.type_vattu;
Padma.symbols[Padma.vattu_LA]    = Padma.type_vattu;
Padma.symbols[Padma.vattu_VA]    = Padma.type_vattu;
Padma.symbols[Padma.vattu_SHA]   = Padma.type_vattu;
Padma.symbols[Padma.vattu_SSA]   = Padma.type_vattu;
Padma.symbols[Padma.vattu_SA]    = Padma.type_vattu;
Padma.symbols[Padma.vattu_HA]    = Padma.type_vattu;
Padma.symbols[Padma.vattu_LLA]   = Padma.type_vattu;
Padma.symbols[Padma.vattu_KSH]   = Padma.type_vattu;   
Padma.symbols[Padma.vattu_RRA]   = Padma.type_vattu;
Padma.symbols[Padma.vattu_TCH]   = Padma.type_vattu;
Padma.symbols[Padma.vattu_TJ]    = Padma.type_vattu;

Padma.isVowel = function (str)
{
    return Padma.symbols[str] == Padma.type_accu;
}

Padma.isSpecial = function (str)
{
    var val = Padma.symbols[str];
    return val == null || val == Padma.type_unknown;
}

Padma.isConsonant = function (str)
{
    return Padma.symbols[str] == Padma.type_hallu;
}

Padma.isDigit = function (str)
{
    return Padma.symbols[str] == Padma.type_digit;
}

Padma.isGunimtam = function (str)
{
    return Padma.symbols[str] == Padma.type_gunimtam;
}

Padma.isVattu = function (str)
{
    return Padma.symbols[str] == Padma.type_vattu;
}

//Ignore everything but the first symbol
Padma.getType = function (str)
{
    if (str == null)
        return Padma.type_unknown;
    var val = Padma.symbols[str[0]];
    return val == null ? Padma.type_unknown : val;
}

Padma.dependentForm = function (str)
{
    var response = "";
    for(var i = 0; i < str.length; ++i) {
        var code = str.charCodeAt(i);
        if (code < 0x80)
            //excludes Padma.vowel_A
            response += String.fromCharCode(code + 0x80);
    }
    return response;
}
